main :- init, action,halt.

init :- 
	load_files('graph.txt'),
	graphs(G1),
	firstEl(Graph,G1),
	nb_setval(gra,Graph), %store the graph in a variable called "gra"!
	load_files('initstate.txt'),
	dirty,
	nb_setval(now,0),
	nb_setval(loc,h1p3), %in the beginning, the robot is at h1p3, the basestat
	nb_setval(batlvl,1000),
	assert(blocked(h3e2,h4e2,500000)). %just to make the blocked predicate known

action :- 
	cleanFirstHall,
	nb_getval(gra,G),
	path(h1p9,h2p7,G,P1,_),
	atR(_,T1),
	write('clean(h1,'),write(T1),write(')'),nl,
	open(facts,append,OUTSTR),write(OUTSTR,'['),write(OUTSTR,T1),
	write(OUTSTR,',pred(clean,[h1])],'),nl(OUTSTR),
	moveAlongPath(P1,T1),
	cleanSecondHall,
	path(h2p2,h3p3,G,P2,_),
	atR(_,T2),
	write('clean(h2,'),write(T2),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T2),write(OUTSTR,',pred(clean,[h2])],'),nl(OUTSTR),
	moveAlongPath(P2,T2),
	cleanThirdHall,
	path(h3p9,h4p7,G,P3,_),
	atR(_,T3),
	write('clean(h3,'),write(T3),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T3),write(OUTSTR,',pred(clean,[h3])],'),nl(OUTSTR),
	moveAlongPath(P3,T3),
	cleanFourthHall,
	path(h4p2,h1p3,G,P4,_),
	atR(_,T4),
	write('clean(h4,'),write(T4),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T4),write(OUTSTR,',pred(clean,[h4])],'),nl(OUTSTR),
	moveAlongPath(P4,T4),
	atR(_,T5),
	stationaryRobot(h1p3,T5,359),
	doLoadMail(360,419),
	mailFirstHall,
	atR(_,T6),
	write('mailAt(h1,'),write(T6),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T6),write(OUTSTR,',pred(mailAt,[h1])],'),nl(OUTSTR),
	moveAlongPath(P1,T6),
	mailSecondHall,
	atR(_,T7),
	write('mailAt(h2,'),write(T7),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T7),write(OUTSTR,',pred(mailAt,[h2])],'),nl(OUTSTR),
	moveAlongPath(P2,T7),
	mailThirdHall,
	atR(_,T8),
	write('mailAt(h3,'),write(T8),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T8),write(OUTSTR,',pred(mailAt,[h3])],'),nl(OUTSTR),
	moveAlongPath(P3,T8),
	mailFourthHall,
	atR(_,T9),
	write('mailAt(h4,'),write(T9),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T9),write(OUTSTR,',pred(mailAt,[h4])],'),nl(OUTSTR),
	moveAlongPath(P4,T9),
	atR(_,T10),
	doLoadFood(T10,659), %659 = 11:29
	foodFirstHall,
	atR(_,T11),
	write('foodAt(h1,'),write(T11),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T11),write(OUTSTR,',pred(foodAt,[h1])],'),nl(OUTSTR),
	moveAlongPath(P1,T11),
	foodSecondHall,
	atR(_,T12),
	write('foodAt(h2,'),write(T12),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T12),write(OUTSTR,',pred(foodAt,[h2])],'),nl(OUTSTR),
	moveAlongPath(P2,T12),
	foodThirdHall,
	atR(_,T13),
	write('foodAt(h3,'),write(T13),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T13),write(OUTSTR,',pred(foodAt,[h3])],'),nl(OUTSTR),
	moveAlongPath(P3,T13),
	foodFourthHall,
	atR(_,T14),
	write('foodAt(h4,'),write(T14),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T14),write(OUTSTR,',pred(foodAt,[h4])],'),nl(OUTSTR),
	moveAlongPath(P4,T14),
	atR(_,T15),
	dishesFirstHall,
	atR(_,T16),
	write('dishesCollected(h1,'),write(T16),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T16),write(OUTSTR,',pred(dishesCollected,[h1])],'),
	nl(OUTSTR),
	moveAlongPath(P1,T16),
	dishesSecondHall,
	atR(_,T17),
	write('dishesCollected(h2,'),write(T17),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T17),write(OUTSTR,',pred(dishesCollected,[h2])],'),
	nl(OUTSTR),
	moveAlongPath(P2,T17),
	dishesThirdHall,
	atR(_,T18),
	write('dishesCollected(h3,'),write(T18),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T18),write(OUTSTR,',pred(dishesCollected,[h3])],'),
	nl(OUTSTR),
	moveAlongPath(P3,T18),
	dishesFourthHall,
	atR(_,T19),
	write('dishesCollected(h4,'),write(T19),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,T19),write(OUTSTR,',pred(dishesCollected,[h4])],'),
	nl(OUTSTR),close(OUTSTR),
	moveAlongPath(P4,T19),
	atR(_,T20),
	stationaryRobot(h1p3,T20,1439),
	write('OK'),nl.
	
doClean(Loc,T) :- 
	dirty(Loc,T1), 
	T1 =< T,
	NewNow is T + 1, 
	nb_setval(now,NewNow),
	nb_getval(batlvl,Lvl),
	NewLvl is Lvl - 1,
	write('batteryLevel('),write(NewLvl),write(','),write(NewNow),write(')'),nl,
	open(facts,append,OUTSTR),write(OUTSTR,'['),write(OUTSTR,NewNow),
	write(OUTSTR,',pred(batteryLevel,['),write(OUTSTR,NewLvl),
	write(OUTSTR,'])],'),nl(OUTSTR),
	nb_setval(batlvl,NewLvl),
	retract(dirty(Loc,T1)),
	write('clean('),write(Loc),write(','),write(NewNow),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,NewNow),write(OUTSTR,',pred(clean,['),
	write(OUTSTR,Loc),write(OUTSTR,'])],'),nl(OUTSTR),close(OUTSTR).
	
doLoadMail(T1,T2) :-
	stationaryRobot(h1p3,T1,T2),
	write('mailLoaded('),write(T2),write(')'),nl,
	open(facts,append,OUTSTR),write(OUTSTR,'['),write(OUTSTR,T2),
	write(OUTSTR,',pred(mailLoaded,[])],'),nl(OUTSTR),close(OUTSTR),
	assert(mailLoaded(T2)).

doDeliverAndCollectMail(L,T) :-
	mailLoaded(T1),
	T1 =< T,
	atR(L,T),
	NewT is T + 2,
	nb_setval(now,NewT),
	nb_getval(batlvl,OldLvl),
	NewLvl is OldLvl - 2,
	nb_setval(batlvl,NewLvl),
	write('batteryLevel('),write(NewLvl),write(','),write(NewT),
	write(')'),nl,
	open(facts,append,OUTSTR),write(OUTSTR,'['),write(OUTSTR,NewT),
	write(OUTSTR,',pred(batteryLevel,['),write(OUTSTR,NewLvl),
	write(OUTSTR,'])],'),nl(OUTSTR),
	assert(mailAt(L,NewT)),
	assert(mailCollected(L,NewT)),
	write('mailAt('),write(L),write(','),write(NewT),write(')'),nl,
	write('mailCollected('),write(L),write(','),write(NewT),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,NewT),write(OUTSTR,',pred(mailAt,['),
	write(OUTSTR,L),write(OUTSTR,'])],'),nl(OUTSTR),
	write(OUTSTR,'['),write(OUTSTR,NewT),
	write(OUTSTR,',pred(mailCollected,['),write(OUTSTR,L),
	write(OUTSTR,'])],'),nl(OUTSTR),close(OUTSTR).
	
doLoadFood(T1,T2) :-
	stationaryRobot(h1p3,T1,T2),
	write('foodLoaded('),write(T2),write(')'),nl,
	open(facts,append,OUTSTR),write(OUTSTR,'['),write(OUTSTR,T2),
	write(OUTSTR,',pred(foodLoaded,[])],'),nl(OUTSTR),close(OUTSTR),
	assert(foodLoaded(T2)).
	
doDeliverFood(L,T) :-
	foodLoaded(T1),
	T1 =< T,
	atR(L,T),
	NewT is T + 2,
	nb_setval(now,NewT),
	nb_getval(batlvl,OldLvl),
	NewLvl is OldLvl - 2,
	nb_setval(batlvl,NewLvl),
	write('batteryLevel('),write(NewLvl),write(','),write(NewT),
	write(')'),nl,
	open(facts,append,OUTSTR),write(OUTSTR,'['),write(OUTSTR,NewT),
	write(OUTSTR,',pred(batteryLevel,['),write(OUTSTR,NewLvl),
	write(OUTSTR,'])],'),nl(OUTSTR),
	assert(foodAt(L,NewT)),
	assert(notDishesCollected(L,NewT)),
	write('foodAt('),write(L),write(','),write(NewT),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,NewT),write(OUTSTR,',pred(foodAt,['),
	write(OUTSTR,L),write(OUTSTR,'])],'),nl(OUTSTR),close(OUTSTR).
	
doCollectDishes(L,T) :-
	atR(L,T),
	notDishesCollected(L,T1),
	T1 =< T,
	NewT is T + 1,
	nb_setval(now,NewT),
	nb_getval(batlvl,OldLvl),
	NewLvl is OldLvl - 1,
	nb_setval(batlvl,NewLvl),
	write('batteryLevel('),write(NewLvl),write(','),write(NewT),write(')'),nl,
	open(facts,append,OUTSTR),write(OUTSTR,'['),write(OUTSTR,NewT),
	write(OUTSTR,',pred(batteryLevel,['),write(OUTSTR,NewLvl),
	write(OUTSTR,'])],'),nl(OUTSTR),
	retract(notDishesCollected(L,T1)),
	write('dishesCollected('),write(L),write(','),write(NewT),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,NewT),write(OUTSTR,',pred(dishesCollected,['),
	write(OUTSTR,L),write(OUTSTR,'])],'),nl(OUTSTR),close(OUTSTR).

	
move(A,B,T,NewT) :- 
	atR(A,T), %are we where we want to start from?
	nb_getval(gra,Graph),
	adjacent(A,B,C,Graph),
	\+ blocked(A,B,T),
	NewT is T+C,
	plus(T,C,NewNow),
	nb_setval(now,NewNow),
	nb_getval(batlvl,OldLvl),
	NewLvl is OldLvl - C,
	nb_setval(batlvl,NewLvl),
	write('batteryLevel('),write(NewLvl),write(','),write(NewT),write(')'),nl,
	open(facts,append,OUTSTR),write(OUTSTR,'['),write(OUTSTR,NewT),
	write(OUTSTR,',pred(batteryLevel,['),write(OUTSTR,NewLvl),
	write(OUTSTR,'])],'),nl(OUTSTR),
	nb_setval(loc,B),
	write('atR('),write(B),write(','),write(NewT),write(')'),nl,
	write(OUTSTR,'['),write(OUTSTR,NewT),write(OUTSTR,',pred(atR,['),
	write(OUTSTR,B),write(OUTSTR,'])],'),nl(OUTSTR),close(OUTSTR).

moveAlongPath(Path,T) :- 
	%write(Path),nl,
	firstEl(A,Path), 
	tailOfList(Path,Tail), 
	firstEl(B,Tail), 
	move(A,B,T,NewT), 
	length(Tail,L),
	(L=1 ; %don't move when the path is done!
	moveAlongPath(Tail,NewT)).
	
stationaryRobot(L,T1,T2) :-
	forall(between(T1,T2,X),(nb_setval(now,X),nb_setval(loc,L))),
	doCharge(T1,T2).
	
doCharge(T1,T2) :- %don't use this directly!
	nb_getval(batlvl,Lvl),
	Minutes is T2 - T1,
	AddLvl is Minutes * 10, %so every minute there is one percent of the lvl recharged... 
	NewLvl is Lvl + AddLvl,
	MinLvl is min(NewLvl,1000), %the battery cannot be loaded above level 1000... 
	nb_setval(batlvl,MinLvl),
	write('batteryLevel('),write(MinLvl),write(','),write(T2),
	write(')'),nl,
	open(facts,append,OUTSTR),write(OUTSTR,'['),write(OUTSTR,T2),
	write(OUTSTR,',pred(batteryLevel,['),write(OUTSTR,MinLvl),
	write(OUTSTR,'])],'),nl(OUTSTR),close(OUTSTR).

path(A,Z,Graph,Path,Cost) :-
	path1(A,[Z],0,Graph,Path,Cost).
path1(A,[A|Path1],Cost1,Graph,[A|Path1],Cost1).
path1(A,[Y|Path1],Cost1,Graph,Path,Cost) :-
	adjacent(X,Y,CostXY,Graph),
	\+ member(X,Path1),
	Cost2 is Cost1 + CostXY,
	path1(A,[X,Y|Path1],Cost2,Graph,Path,Cost).
	
atR(Loc,T) :- 
	nb_getval(now,T),
	nb_getval(loc,Loc).
	
%%Helper functions
%List functions
%get the first element of a list in F.
firstEl(F,[F|_]). 

tailOfList([_|Tail],Tail). 

member(X,[X|Tail]).
member(X,[Head|Tail]) :-
	member(X,Tail).
	
%Graph functions
adjacent(X,Y,CostXY,graph(Nodes,Edges)) :-
	member(e(X,Y,CostXY),Edges);
	member(e(Y,X,CostXY),Edges).

getGraph(Graph) :-	
    load_files('graph.txt'),
	graphs(G1),
	firstEl(Graph,G1).

%utilities
cleanFirstHall :- 
	nb_getval(loc,L),
	nb_getval(now,Tnow),
	doClean(L,Tnow),
	nb_getval(gra,G),
	
	path(L, h1p1, G, P,_),
	nb_getval(now,T),
	moveAlongPath(P,T),
	nb_getval(now,T1),
	nb_getval(loc,L1),
	doClean(L1,T1),
	
	path(L1,h1p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doClean(L2,T4),
	
 	path(L2,h1p4, G, P2,_),
	nb_getval(now,T5),
	moveAlongPath(P2,T5),
	nb_getval(now,T6),
	nb_getval(loc,L3),
	doClean(L3,T6),
	
	path(L3,h1p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doClean(L4,T8),
	
	path(L4,h1p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doClean(L5,T10),
	
	path(L5,h1p7, G, P5,_),
	nb_getval(now,T11),
	moveAlongPath(P5,T11),
	nb_getval(now,T12),
	nb_getval(loc,L6),
	doClean(L6,T12),
	
	path(L6,h1p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doClean(L7,T14), 
	
	path(L7,h1p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doClean(L8,T16).
	
cleanSecondHall :-
	nb_getval(loc,L),
	nb_getval(now,Tnow),
	doClean(L,Tnow),
	nb_getval(gra,G),
	
	path(L,h2p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doClean(L8,T16),
	
	path(L8,h2p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doClean(L7,T14), 
	
	path(L7,h2p4, G, P2,_),
	nb_getval(now,T5),
	moveAlongPath(P2,T5),
	nb_getval(now,T6),
	nb_getval(loc,L3),
	doClean(L3,T6),
	
	path(L3,h2p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doClean(L5,T10),
	
	path(L5,h2p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doClean(L4,T8),
	
	path(L4, h2p1, G, P,_),
	nb_getval(now,T),
	moveAlongPath(P,T),
	nb_getval(now,T1),
	nb_getval(loc,L1),
	doClean(L1,T1),
	
	path(L1,h2p3, G, P5,_),
	nb_getval(now,T11),
	moveAlongPath(P5,T11),
	nb_getval(now,T12),
	nb_getval(loc,L6),
	doClean(L6,T12),
	
	path(L6,h2p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doClean(L2,T4).
	
cleanThirdHall :-
	nb_getval(loc,L),
	nb_getval(now,Tnow),
	doClean(L,Tnow),
	nb_getval(gra,G),

	path(L, h3p1, G, P,_),
	nb_getval(now,T),
	moveAlongPath(P,T),
	nb_getval(now,T1),
	nb_getval(loc,L1),
	doClean(L1,T1),
	
	path(L1,h3p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doClean(L2,T4),
	
 	path(L2,h3p4, G, P2,_),
	nb_getval(now,T5),
	moveAlongPath(P2,T5),
	nb_getval(now,T6),
	nb_getval(loc,L3),
	doClean(L3,T6),
	
	path(L3,h3p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doClean(L4,T8),
	
	path(L4,h3p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doClean(L5,T10),
	
	path(L5,h3p7, G, P5,_),
	nb_getval(now,T11),
	moveAlongPath(P5,T11),
	nb_getval(now,T12),
	nb_getval(loc,L6),
	doClean(L6,T12),
	
	path(L6,h3p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doClean(L7,T14), 
	
	path(L7,h3p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doClean(L8,T16).

cleanFourthHall :-
	nb_getval(loc,L),
	nb_getval(now,Tnow),
	doClean(L,Tnow),
	nb_getval(gra,G),
	
	path(L,h4p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doClean(L8,T16),
	
	path(L8,h4p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doClean(L7,T14), 
	
	path(L7,h4p4, G, P2,_),
	nb_getval(now,T5),
	moveAlongPath(P2,T5),
	nb_getval(now,T6),
	nb_getval(loc,L3),
	doClean(L3,T6),
	
	path(L3,h4p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doClean(L5,T10),
	
	path(L5,h4p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doClean(L4,T8),
	
	path(L4, h4p1, G, P,_),
	nb_getval(now,T),
	moveAlongPath(P,T),
	nb_getval(now,T1),
	nb_getval(loc,L1),
	doClean(L1,T1),
	
	path(L1,h4p3, G, P5,_),
	nb_getval(now,T11),
	moveAlongPath(P5,T11),
	nb_getval(now,T12),
	nb_getval(loc,L6),
	doClean(L6,T12),
	
	path(L6,h4p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doClean(L2,T4).


mailFirstHall :- 
	nb_getval(loc,L),
	nb_getval(gra,G),
	
	path(L,h1p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doDeliverAndCollectMail(L2,T4),
	
	path(L2,h1p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doDeliverAndCollectMail(L4,T8),
	
	path(L4,h1p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doDeliverAndCollectMail(L5,T10),
	
	path(L5,h1p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doDeliverAndCollectMail(L7,T14), 
	
	path(L7,h1p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doDeliverAndCollectMail(L8,T16).
	
mailSecondHall :-
	nb_getval(loc,L),
	nb_getval(gra,G),
	
	path(L,h2p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doDeliverAndCollectMail(L8,T16),
	
	path(L8,h2p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doDeliverAndCollectMail(L7,T14), 
	
	path(L7,h2p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doDeliverAndCollectMail(L5,T10),
	
	path(L5,h2p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doDeliverAndCollectMail(L4,T8),
	
	path(L4,h2p3, G, P5,_),
	nb_getval(now,T11),
	moveAlongPath(P5,T11),
	nb_getval(now,T12),
	nb_getval(loc,L6),
	doDeliverAndCollectMail(L6,T12),
	
	path(L6,h2p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doDeliverAndCollectMail(L2,T4).
	
mailThirdHall :-
	nb_getval(loc,L),
	nb_getval(now,Tnow),
	doDeliverAndCollectMail(L,Tnow),
	nb_getval(gra,G),
	
	path(L,h3p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doDeliverAndCollectMail(L2,T4),
	
	path(L2,h3p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doDeliverAndCollectMail(L4,T8),
	
	path(L4,h3p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doDeliverAndCollectMail(L5,T10),
	
	path(L5,h3p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doDeliverAndCollectMail(L7,T14), 
	
	path(L7,h3p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doDeliverAndCollectMail(L8,T16).

mailFourthHall :-
	nb_getval(loc,L),
	nb_getval(gra,G),
	
	path(L,h4p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doDeliverAndCollectMail(L8,T16),
	
	path(L8,h4p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doDeliverAndCollectMail(L7,T14), 
	
	path(L7,h4p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doDeliverAndCollectMail(L5,T10),
	
	path(L5,h4p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doDeliverAndCollectMail(L4,T8),
	
	path(L4,h4p3, G, P5,_),
	nb_getval(now,T11),
	moveAlongPath(P5,T11),
	nb_getval(now,T12),
	nb_getval(loc,L6),
	doDeliverAndCollectMail(L6,T12),
	
	path(L6,h4p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doDeliverAndCollectMail(L2,T4).

foodFirstHall :- 
	nb_getval(loc,L),
	nb_getval(gra,G),
	
	path(L,h1p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doDeliverFood(L2,T4),
	
	path(L2,h1p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doDeliverFood(L4,T8),
	
	path(L4,h1p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doDeliverFood(L5,T10),
	
	path(L5,h1p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doDeliverFood(L7,T14), 
	
	path(L7,h1p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doDeliverFood(L8,T16).
	
foodSecondHall :-
	nb_getval(loc,L),
	nb_getval(gra,G),
	
	path(L,h2p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doDeliverFood(L8,T16),
	
	path(L8,h2p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doDeliverFood(L7,T14), 
	
	path(L7,h2p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doDeliverFood(L5,T10),
	
	path(L5,h2p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doDeliverFood(L4,T8),
	
	path(L4,h2p3, G, P5,_),
	nb_getval(now,T11),
	moveAlongPath(P5,T11),
	nb_getval(now,T12),
	nb_getval(loc,L6),
	doDeliverFood(L6,T12),
	
	path(L6,h2p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doDeliverFood(L2,T4).
	
foodThirdHall :-
	nb_getval(loc,L),
	nb_getval(now,Tnow),
	doDeliverFood(L,Tnow),
	nb_getval(gra,G),
	
	path(L,h3p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doDeliverFood(L2,T4),
	
	path(L2,h3p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doDeliverFood(L4,T8),
	
	path(L4,h3p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doDeliverFood(L5,T10),
	
	path(L5,h3p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doDeliverFood(L7,T14), 
	
	path(L7,h3p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doDeliverFood(L8,T16).

foodFourthHall :-
	nb_getval(loc,L),
	nb_getval(gra,G),
	
	path(L,h4p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doDeliverFood(L8,T16),
	
	path(L8,h4p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doDeliverFood(L7,T14), 
	
	path(L7,h4p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doDeliverFood(L5,T10),
	
	path(L5,h4p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doDeliverFood(L4,T8),
	
	path(L4,h4p3, G, P5,_),
	nb_getval(now,T11),
	moveAlongPath(P5,T11),
	nb_getval(now,T12),
	nb_getval(loc,L6),
	doDeliverFood(L6,T12),
	
	path(L6,h4p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doDeliverFood(L2,T4).

dishesFirstHall :- 
	nb_getval(loc,L),
	nb_getval(gra,G),
	
	path(L,h1p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doCollectDishes(L2,T4),
	
	path(L2,h1p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doCollectDishes(L4,T8),
	
	path(L4,h1p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doCollectDishes(L5,T10),
	
	path(L5,h1p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doCollectDishes(L7,T14), 
	
	path(L7,h1p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doCollectDishes(L8,T16).
	
dishesSecondHall :-
	nb_getval(loc,L),
	nb_getval(gra,G),
	
	path(L,h2p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doCollectDishes(L8,T16),
	
	path(L8,h2p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doCollectDishes(L7,T14), 
	
	path(L7,h2p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doCollectDishes(L5,T10),
	
	path(L5,h2p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doCollectDishes(L4,T8),
	
	path(L4,h2p3, G, P5,_),
	nb_getval(now,T11),
	moveAlongPath(P5,T11),
	nb_getval(now,T12),
	nb_getval(loc,L6),
	doCollectDishes(L6,T12),
	
	path(L6,h2p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doCollectDishes(L2,T4).
	
dishesThirdHall :-
	nb_getval(loc,L),
	nb_getval(now,Tnow),
	doCollectDishes(L,Tnow),
	nb_getval(gra,G),
	
	path(L,h3p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doCollectDishes(L2,T4),
	
	path(L2,h3p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doCollectDishes(L4,T8),
	
	path(L4,h3p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doCollectDishes(L5,T10),
	
	path(L5,h3p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doCollectDishes(L7,T14), 
	
	path(L7,h3p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doCollectDishes(L8,T16).

dishesFourthHall :-
	nb_getval(loc,L),
	nb_getval(gra,G),
	
	path(L,h4p9, G, P7,_),
	nb_getval(now,T15),
	moveAlongPath(P7,T15),
	nb_getval(now,T16),
	nb_getval(loc,L8),
	doCollectDishes(L8,T16),
	
	path(L8,h4p8, G, P6,_),
	nb_getval(now,T13),
	moveAlongPath(P6,T13),
	nb_getval(now,T14),
	nb_getval(loc,L7),
	doCollectDishes(L7,T14), 
	
	path(L7,h4p6, G, P4,_),
	nb_getval(now,T9),
	moveAlongPath(P4,T9),
	nb_getval(now,T10),
	nb_getval(loc,L5),
	doCollectDishes(L5,T10),
	
	path(L5,h4p5, G, P3,_),
	nb_getval(now,T7),
	moveAlongPath(P3,T7),
	nb_getval(now,T8),
	nb_getval(loc,L4),
	doCollectDishes(L4,T8),
	
	path(L4,h4p3, G, P5,_),
	nb_getval(now,T11),
	moveAlongPath(P5,T11),
	nb_getval(now,T12),
	nb_getval(loc,L6),
	doCollectDishes(L6,T12),
	
	path(L6,h4p2, G, P1,_),
	nb_getval(now,T3),
	moveAlongPath(P1,T3),
	nb_getval(now,T4),
	nb_getval(loc,L2),
	doCollectDishes(L2,T4).

